public class Address
{
    private String town;
    private String street;
    private int    number;
    private String gps;
    
    public Address(String town, String street, int number) {
        this.town = town;
        this.street = street;
        this.number = number;
    }
    
    public String toString() {
        return street + " " + number + ", " + town;
    }
    
    public boolean equals(Object obj) {
        if (! (obj instanceof Address)) {
            return false;
        }
        
        Address addr = (Address) obj;
        return town.equals(addr.town) &&
            street.equals(addr.street) &&
            number == addr.number;
    }
    
    public int hashCode() {
        int hash = 14;
        hash = hash * 31 + town.hashCode();
        hash = hash * 31 + street.hashCode();
        hash = hash * 31 + (new Integer(number)).hashCode();
        return hash;
    }
}






