import java.util.*;

public class Company
{
    private String name;
    
    public Company(String n) {
        this.name = n;
    }
    
    public String toString() {
        return "Company " + name;
    }
    
    public String getName() {
        return name;
    }  
    
    public boolean equals(Object obj) {
        //return this.hashCode() == obj.hashCode();
        if (!(obj instanceof Company)) {
            return false;
        }
        
        if (obj == this) {
            return true;
        }
        
        Company comp = (Company) obj;
        return getName().equals(comp.getName());
    }
    
    public int hashCode() {
        return name.hashCode();
    }
}

















